<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ContextBuilder.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">protean-tests</a> &gt; <a href="index.source.html" class="el_package">io.gitlab.littlesaints.protean.context</a> &gt; <span class="el_source">ContextBuilder.java</span></div><h1>ContextBuilder.java</h1><pre class="source lang-java linenums">/*
 *                     protean-core
 *              Copyright (C) 2018 Varun Anand
 *
 * This file is part of protean-core.
 *
 * protean-core is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 *
 * protean-core is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see &lt;http://www.gnu.org/licenses/&gt;.
 */

package io.gitlab.littlesaints.protean.context;

import io.gitlab.littlesaints.protean.Constants;
import io.gitlab.littlesaints.protean.Context;
import io.gitlab.littlesaints.protean.EventExecutor;
import io.gitlab.littlesaints.protean.Graph;
import io.gitlab.littlesaints.protean.analytics.AggregateStatsListener;
import io.gitlab.littlesaints.protean.analytics.StatsListener;
import io.gitlab.littlesaints.protean.analytics.StatsLogger;
import io.gitlab.littlesaints.protean.configuration.*;
import io.gitlab.littlesaints.protean.event.EventAccessor;
import io.gitlab.littlesaints.protean.event.EventCache;
import io.gitlab.littlesaints.protean.executors.sync.SyncExecutor;
import io.gitlab.littlesaints.protean.resources.ProteanResources;
import io.gitlab.littlesaints.protean.resources.ResourceLocator;
import io.gitlab.littlesaints.protean.throttle.Throttle;

import java.util.List;
import java.util.Objects;
import java.util.Optional;
import java.util.function.BiConsumer;
import java.util.function.Consumer;
import java.util.function.Function;
import java.util.function.Supplier;
import java.util.stream.Collectors;

/**
 * A builder for {@link Context}.
 * An instance of this class can be created using {@link #newInstance(String, Configuration)}.
 * The class provides various methods to build a {@link Context}.
 * &lt;p&gt;
 * This class is NOT thread-safe.
 * &lt;/p&gt;
 *
 * @param &lt;P&gt; the getType of payload to submit for execution.
 * @author Varun Anand
 * @see Context
 * @since 0.1
 */
public final class ContextBuilder&lt;E, P, R&gt; implements Supplier&lt;Context&lt;P, R&gt;&gt; {

    private final Configuration configuration;

    private final ResourceLocator locator;

    private final String contextName;

    private final ContextOptions contextOptions;

    private AggregateStatsListener&lt;E&gt; statsListener;

    private Throttle throttle;

<span class="fc" id="L74">    private ContextBuilder(String contextName, Configuration configuration) {</span>
<span class="fc" id="L75">        this.contextName = contextName;</span>
<span class="fc" id="L76">        this.configuration = configuration;</span>
<span class="fc" id="L77">        this.locator = Configuration.LOCATOR;</span>
<span class="fc" id="L78">        this.contextOptions = configuration.getContextOptions(contextName).orElseThrow(IllegalArgumentException::new);</span>
<span class="fc" id="L79">    }</span>

    public static &lt;E, P, R&gt; ContextBuilder&lt;E, P, R&gt; newInstance(String contextName, Configuration configuration) {
<span class="fc" id="L82">        return new ContextBuilder&lt;&gt;(contextName, configuration);</span>
    }

    public EventExecutor&lt;P, R&gt; buildExecutor() {

<span class="fc" id="L87">        final EventAccessor&lt;E, P&gt; eventAccessor = buildAccessor();</span>

<span class="fc" id="L89">        Optional&lt;Consumer&lt;E&gt;&gt; ackListenerRef = Optional.empty();</span>

<span class="fc" id="L91">        final Optional&lt;EventCache&lt;E&gt;&gt; eventCacheRef = buildEventCache(eventAccessor);</span>
        final Function&lt;Config, E&gt; constructor;
<span class="pc bpc" id="L93" title="1 of 2 branches missed.">        if (eventCacheRef.isPresent()) {</span>
<span class="nc" id="L94">            final EventCache&lt;E&gt; eventCache = eventCacheRef.get();</span>
<span class="nc" id="L95">            constructor = c -&gt; eventCache.get();</span>
<span class="nc" id="L96">            ackListenerRef = Optional.of(eventCache::put);</span>
<span class="nc" id="L97">        } else {</span>
<span class="pc bpc" id="L98" title="1 of 2 branches missed.">            if (SyncExecutor.TYPE.equals(contextOptions.getExecutor().getType().getSupplier())) {</span>
<span class="fc" id="L99">                contextOptions.getEvent().getType().setSupplier(ProteanResources.SINGLE_THREAD_EVENT_SUPPLIER);</span>
            }
<span class="fc" id="L101">            constructor = buildEventSupplier();</span>
        }
<span class="fc" id="L103">        Objects.requireNonNull(constructor, &quot;constructor cannot be null !!&quot;);</span>

<span class="fc" id="L105">        this.throttle = buildThrottle().orElse(null);</span>
<span class="pc bpc" id="L106" title="1 of 2 branches missed.">        if (throttle != null) {</span>
<span class="nc" id="L107">            final Consumer&lt;E&gt; c = e -&gt; throttle.release();</span>
<span class="nc bnc" id="L108" title="All 2 branches missed.">            if (ackListenerRef.isPresent()) {</span>
<span class="nc" id="L109">                ackListenerRef = ackListenerRef.map(ackL -&gt; ackL.andThen(c));</span>
            } else {
<span class="nc" id="L111">                ackListenerRef = Optional.of(c);</span>
            }
        }

<span class="fc" id="L115">        final Optional&lt;Function&lt;E, String&gt;&gt; refIdResolverRef = locator.lookup(contextOptions.getEvent().getReferenceIdResolver());</span>
        final Function&lt;E, String&gt; idResolver;
<span class="pc bpc" id="L117" title="1 of 2 branches missed.">        if (refIdResolverRef.isPresent()) {</span>
<span class="nc" id="L118">            final Function&lt;E, String&gt; refIdResolver = refIdResolverRef.get();</span>
<span class="nc" id="L119">            idResolver = e -&gt; refIdResolver.apply(e) + &quot;|&quot; + eventAccessor.getIdentifier(e);</span>
<span class="nc" id="L120">        } else {</span>
<span class="fc" id="L121">            idResolver = e -&gt; &quot;&quot; + eventAccessor.getIdentifier(e);</span>
        }

<span class="fc" id="L124">        this.statsListener = buildAggregateStatsListener(idResolver);</span>
<span class="fc" id="L125">        final boolean doStatistics = contextOptions.getAnalytics().isStatistics();</span>
<span class="fc bfc" id="L126" title="All 2 branches covered.">        if (doStatistics) {</span>
<span class="fc" id="L127">            final Consumer&lt;E&gt; c = e -&gt; statsListener.eventProcessed(contextName, e, Constants.Statistics.E2E,</span>
<span class="fc" id="L128">                    eventAccessor.getStartEpochMillis(e), System.currentTimeMillis());</span>
<span class="pc bpc" id="L129" title="1 of 2 branches missed.">            if (ackListenerRef.isPresent()) {</span>
<span class="nc" id="L130">                ackListenerRef = ackListenerRef.map(ackL -&gt; ackL.andThen(c));</span>
            } else {
<span class="fc" id="L132">                ackListenerRef = Optional.of(c);</span>
            }
        }

<span class="fc" id="L136">        final Function&lt;E, R&gt; resultResolver = locator.lookupOrThrow(contextOptions.getResultMapper(), &quot;Result Evaluator&quot;);</span>

<span class="fc" id="L138">        final EventExecutor&lt;P, R&gt; executor = buildExecutor(() -&gt; constructor.apply(new Config(contextOptions.getEvent().getType().getConfig())),</span>
<span class="fc bfc" id="L139" title="All 2 branches covered.">                eventAccessor, idResolver, ackListenerRef.orElse(e -&gt; {</span>
<span class="fc" id="L140">                }), doStatistics ? statsListener : null, resultResolver);</span>

<span class="fc" id="L142">        Objects.requireNonNull(executor, &quot;executor cannot be null !!&quot;);</span>

<span class="fc" id="L144">        return executor;</span>
    }

    public Context&lt;P, R&gt; get() {
<span class="fc" id="L148">        return Context.REGISTRY.lookupOrThrow(contextOptions.getProvider(), &quot;Context Provider&quot;)</span>
<span class="fc" id="L149">                .newInstance(contextName, configuration, statsListener, buildExecutor(), throttle);</span>
    }

    private Optional&lt;EventCache&lt;E&gt;&gt; buildEventCache(EventAccessor&lt;E, P&gt; eventAccessor) {
<span class="fc" id="L153">        final CacheOptions cacheOptions = contextOptions.getEvent().getCache();</span>
<span class="pc bpc" id="L154" title="1 of 2 branches missed.">        if (cacheOptions == null) {</span>
<span class="fc" id="L155">            return Optional.empty();</span>
        }
<span class="nc" id="L157">        return Optional.of(EventCache.REGISTRY.lookupOrThrow(cacheOptions.getType().getSupplier(), &quot;EventCache&quot;)</span>
<span class="nc" id="L158">                .newInstance(new Config(cacheOptions.getType().getConfig()),</span>
<span class="nc bnc" id="L159" title="All 2 branches missed.">                        cacheOptions.getSize() == 0 ? contextOptions.getExecutor().getBuffer() : cacheOptions.getSize(),</span>
                        p -&gt; {
<span class="nc" id="L161">                            Props props = new Props();</span>
<span class="nc" id="L162">                            props.putAll(p);</span>
<span class="nc" id="L163">                            props.putAll(contextOptions.getEvent().getType().getConfig());</span>
<span class="nc" id="L164">                            return buildEventSupplier().apply(new Config(props));</span>
                        }, eventAccessor));
    }

    private EventAccessor&lt;E, P&gt; buildAccessor() {
<span class="fc" id="L169">        return locator.lookupOrThrow(contextOptions.getEvent().getAccessor(), &quot;Accessor&quot;);</span>
    }

    private EventExecutor&lt;P, R&gt; buildExecutor(Supplier&lt;E&gt; constructor, EventAccessor&lt;E, P&gt; eventAccessor, Function&lt;E, String&gt; idResolver,
                                              Consumer&lt;E&gt; ackListener, StatsListener&lt;E&gt; statsListener,
                                              Function&lt;E, R&gt; resultResolver) {
<span class="fc" id="L175">        final Graph&lt;E&gt; graph = Graph.&lt;E&gt;configure().configuration(configuration)</span>
<span class="fc" id="L176">                .locator(locator)</span>
<span class="fc" id="L177">                .options(contextOptions.getWorkflow())</span>
<span class="fc" id="L178">                .get();</span>
<span class="fc" id="L179">        Objects.requireNonNull(graph, &quot;workflow cannot be null !!&quot;);</span>
<span class="fc" id="L180">        final BiConsumer&lt;E, P&gt; initializer = buildInitializer(eventAccessor);</span>
<span class="fc" id="L181">        final ExecutorOptions executorOptions = contextOptions.getExecutor();</span>
<span class="fc" id="L182">        return EventExecutor.REGISTRY.lookupOrThrow(executorOptions.getType().getSupplier(), &quot;Executor&quot;)</span>
<span class="fc" id="L183">                .newInstance(contextName, executorOptions, constructor, graph, initializer, ackListener, eventAccessor,</span>
<span class="fc bfc" id="L184" title="All 2 branches covered.">                        contextOptions.getAnalytics().isStatistics() ? statsListener : null, contextOptions.isCleanShutdown(), resultResolver);</span>
    }

    private BiConsumer&lt;E, P&gt; buildInitializer(EventAccessor&lt;E, P&gt; eventAccessor) {
<span class="fc" id="L188">        Objects.requireNonNull(eventAccessor, &quot;initializer cannot be null !!&quot;);</span>
<span class="fc" id="L189">        return eventAccessor::initialize;</span>
    }

    private AggregateStatsListener&lt;E&gt; buildAggregateStatsListener(Function&lt;E, String&gt; idResolver) {
<span class="fc" id="L193">        final List&lt;StatsListener&lt;E&gt;&gt; listeners = contextOptions.getAnalytics().getListeners().stream()</span>
<span class="fc" id="L194">                .map(this::&lt;StatsListener&lt;E&gt;&gt;lookupGenericOptions)</span>
<span class="fc" id="L195">                .filter(Optional::isPresent)</span>
<span class="fc" id="L196">                .map(Optional::get)</span>
<span class="fc" id="L197">                .collect(Collectors.toList());</span>
<span class="fc" id="L198">        listeners.add(new StatsLogger&lt;&gt;(idResolver));</span>
<span class="fc" id="L199">        return new AggregateStatsListener&lt;&gt;(listeners);</span>
    }

    private Function&lt;Config, E&gt; buildEventSupplier() {
<span class="fc" id="L203">        return locator.lookupOrThrow(contextOptions.getEvent().getType().getSupplier(), &quot;EventSupplier&quot;);</span>
    }

    private Optional&lt;Throttle&gt; buildThrottle() {
        final Throttle throttle;
        {
<span class="pc bpc" id="L209" title="1 of 2 branches missed.">            if (contextOptions.getThrottle() == null) {</span>
<span class="fc" id="L210">                throttle = null;</span>
            } else {
<span class="nc" id="L212">                ThrottleOptions o = contextOptions.getThrottle();</span>
<span class="nc" id="L213">                throttle = Throttle.REGISTRY.lookupOrThrow(o.getType().getSupplier(), &quot;Throttle&quot;)</span>
<span class="nc" id="L214">                        .newInstance(new Config(o.getType().getConfig()),</span>
<span class="nc" id="L215">                                o.getListeners().stream()</span>
<span class="nc" id="L216">                                        .map(this::&lt;Consumer&lt;Boolean&gt;&gt;lookupGenericOptions)</span>
<span class="nc" id="L217">                                        .filter(Optional::isPresent)</span>
<span class="nc" id="L218">                                        .map(Optional::get)</span>
<span class="nc" id="L219">                                        .reduce(Consumer::andThen)</span>
<span class="nc" id="L220">                                        .orElse(b -&gt; {</span>
<span class="nc" id="L221">                                        }));</span>
            }
        }
<span class="fc" id="L224">        return Optional.ofNullable(throttle);</span>
    }

    private &lt;T&gt; Optional&lt;T&gt; lookupGenericOptions(GenericOptions options) {
<span class="fc bfc" id="L228" title="All 2 branches covered.">        if (options.getConfig().isEmpty()) {</span>
<span class="fc" id="L229">            return locator.&lt;Supplier&lt;T&gt;&gt;lookup(options.getSupplier()).map(Supplier::get);</span>
        } else {
<span class="fc" id="L231">            return locator.&lt;Function&lt;Config, T&gt;&gt;lookup(options.getSupplier())</span>
<span class="fc" id="L232">                    .map(f -&gt; f.apply(Config.from(options.getConfig())));</span>
        }
    }

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.4.201905082037</span></div></body></html>